/**
 * Yonius 0.1.2.
 *
 * Copyright (c) 2008-2019 Hive Solutions Lda.
 *
 * This source code is licensed under the Apache 2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
(function(g,f){typeof exports==='object'&&typeof module!=='undefined'?f(exports,require('node-fetch')):typeof define==='function'&&define.amd?define(['exports','node-fetch'],f):(g=g||self,f(g.yonius={},g.fetch));}(this,function(exports, fetch){'use strict';fetch=fetch&&fetch.hasOwnProperty('default')?fetch['default']:fetch;class Observable {
    constructor() {
        this.callbacks = {};
    }

    bind(event, callback) {
        const callbacks = this.callbacks[event] || [];
        callbacks.push(callback);
        this.callbacks[event] = callbacks;
        return callback;
    }

    unbind(event, callback) {
        const callbacks = this.callbacks[event] || [];
        if (!callback) {
            delete this.callbacks[event];
            return;
        }

        const index = callbacks.indexOf(callback);
        if (index === -1) {
            return;
        }
        callbacks.splice(index, 1);
        this.callbacks[event] = callbacks;
    }

    trigger(event) {
        const callbacks = this.callbacks[event] || [];
        const results = [];
        for (const callback of callbacks) {
            let result = callback.apply(this, Array.prototype.slice.call(arguments, 1));
            result !== undefined && result !== null && results.push(result);
        }
        return Promise.all(results);
    }
}class API extends Observable {
    async get(
        url,
        headers = null,
        params = null,
        handle = null,
        silent = null,
        redirect = null,
        timeout = null,
        callback = null,
        extra = null
    ) {
        const response = await fetch(url, {
            method: "GET",
            headers: headers || {}
        });
        const result = await this._handleResponse(response);
        return result;
    }

    async _handleResponse(response) {
        let result = null;
        if (response.headers.get("content-type").toLowerCase() === "application/json") {
            result = await response.json();
        } else {
            result = await response.blob();
        }
        return result;
    }
}class OAuthAPI extends API {}class OAuth1API extends OAuthAPI {}class OAuth2API extends OAuthAPI {}exports.API=API;exports.OAuth1API=OAuth1API;exports.OAuth2API=OAuth2API;exports.OAuthAPI=OAuthAPI;exports.Observable=Observable;Object.defineProperty(exports,'__esModule',{value:true});}));//# sourceMappingURL=yonius.umd.js.map
